<?php
//
// +----------------------------------------------------------------------+
// |zen-cart Open Source E-commerce                                       |
// +----------------------------------------------------------------------+
// | Copyright (c) 2003 The zen-cart developers                           |
// |                                                                      |
// | http://www.zen-cart.com/index.php                                    |
// |                                                                      |
// | Portions Copyright (c) 2003 osCommerce                               |
// +----------------------------------------------------------------------+
// | This source file is subject to version 2.0 of the GPL license,       |
// | that is bundled with this package in the file LICENSE, and is        |
// | available through the world-wide-web at the following url:           |
// | http://www.zen-cart.com/license/2_0.txt.                             |
// | If you did not receive a copy of the zen-cart license and are unable |
// | to obtain it through the world-wide-web, please send a note to       |
// | license@zen-cart.com so we can mail you a copy immediately.          |
// +----------------------------------------------------------------------+
// $Id: rechnung.php 2012_04_06 Hausl $
//

  class rechnung {
    var $code, $title, $description, $enabled, $payment;

// class constructor
    function rechnung() {
      global $order;
      $this->code = 'rechnung';
      $this->title = MODULE_PAYMENT_RECHNUNG_TEXT_TITLE;
      $this->description = MODULE_PAYMENT_RECHNUNG_TEXT_DESCRIPTION;
      $this->sort_order = MODULE_PAYMENT_RECHNUNG_SORT_ORDER;
      $this->enabled = ((MODULE_PAYMENT_RECHNUNG_STATUS == 'True') ? true : false);

      if ((int)MODULE_PAYMENT_RECHNUNG_ORDER_STATUS_ID > 0) {
        $this->order_status = MODULE_PAYMENT_RECHNUNG_ORDER_STATUS_ID;
        $payment='rechnung';
      } else {
        if ($payment=='rechnung') {
          $payment='';
        }
      }

      if (is_object($order)) $this->update_status();

      $this->email_footer = MODULE_PAYMENT_RECHNUNG_TEXT_EMAIL_FOOTER;
    }

// class methods
    function update_status() {
      global $db;
      global $order;

	  $group_query = $db->Execute("select customers_invoice from " . TABLE_CUSTOMERS . " where customers_id = '" . (int)$_SESSION['customer_id'] . "'");
      if ($this->enabled == true) {
        $check_flag_group = false;
		
        if ($group_query->RecordCount() ==  1) {
          $invoice_prefix = "1"; 
          $check_prefix = substr($group_query->fields['customers_invoice'], 0, strlen($invoice_prefix));
          if (strcasecmp($check_prefix, $invoice_prefix) == 0) {
            $check_flag_group = true;
          }
        }
        if ($check_flag_group == false) {
          $this->enabled = false;
        }
      }

// disable the module if the order only contains virtual products
      if ($this->enabled == true) {
        if ($order->content_type != 'physical') {
          $this->enabled = false;
        }
      }


    }

    function javascript_validation() {
      return false;
    }

    function selection() {
      return array('id' => $this->code,
                   'module' => $this->title);
    }

    function pre_confirmation_check() {
      return false;
    }

    function confirmation() {
      return array('title' => MODULE_PAYMENT_RECHNUNG_TEXT_DESCRIPTION);
    }

    function process_button() {
      return false;
    }

    function before_process() {
      return false;
    }

    function after_process() {
      return false;
    }

    function get_error() {
      return false;
    }

    function check() {
      global $db;
      if (!isset($this->_check)) {
        $check_query = $db->Execute("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_RECHNUNG_STATUS'");
        $this->_check = $check_query->RecordCount();
      }
      return $this->_check;
    }

    function install() {
      global $db;
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable invoice Module', 'MODULE_PAYMENT_RECHNUNG_STATUS', 'True', 'Do you want to accept invoice payments?', '6', '7', 'zen_cfg_select_option(array(\'True\', \'False\'), ', now());");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort order of display.', 'MODULE_PAYMENT_RECHNUNG_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '0', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Payment Zone', 'MODULE_PAYMENT_RECHNUNG_ZONE', '0', 'If a zone is selected, only enable this payment method for that zone.', '6', '2', 'zen_get_zone_class_title', 'zen_cfg_pull_down_zone_classes(', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Set Order Status', 'MODULE_PAYMENT_RECHNUNG_ORDER_STATUS_ID', '0', 'Set the status of orders made with this payment module to this value', '6', '0', 'zen_cfg_pull_down_order_statuses(', 'zen_get_order_status_name', now())");
// www.zen-cart.at r.l. languages_id==43 START
      $db->Execute("insert into " . TABLE_CONFIGURATION_LANGUAGE   . " (configuration_title, configuration_key, configuration_language_id, configuration_description, date_added) values ('Lieferung auf Rechnung', 'MODULE_PAYMENT_RECHNUNG_STATUS', '43', 'Wollen Sie Lieferung auf Rechnung aktivieren?', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION_LANGUAGE   . " (configuration_title, configuration_key, configuration_language_id, configuration_description, date_added) values ('Zone', 'MODULE_PAYMENT_RECHNUNG_SORT_ORDER', '43', 'Wenn eine Zone ausgew&auml;hlt wird, ist diese Bezahlart nur in dieser Zone aktiviert.', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION_LANGUAGE   . " (configuration_title, configuration_key, configuration_language_id, configuration_description, date_added) values ('Sortierreihenfolge', 'MODULE_PAYMENT_RECHNUNG_ZONE', '43', 'Anzuzeigende Sortierreihenfolge. Die Niedrigste wird zuerst angezeigt.', now())");
      $db->Execute("insert into " . TABLE_CONFIGURATION_LANGUAGE   . " (configuration_title, configuration_key, configuration_language_id, configuration_description, date_added) values ('Bestellstatus', 'MODULE_PAYMENT_RECHNUNG_ORDER_STATUS_ID', '43', 'Bestellungen, die mit diesem Modul get&auml;tigt werden, werden auf diesen Bestellstatus eingestellt', now())");
// www.zen-cart.at r.l. languages_id==43  END
    }

    function remove() {
      global $db;
      $db->Execute("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
// www.zen-cart.at r.l. languages_id == delete all
      $db->Execute("delete from " . TABLE_CONFIGURATION_LANGUAGE . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_PAYMENT_RECHNUNG_STATUS', 'MODULE_PAYMENT_RECHNUNG_ZONE', 'MODULE_PAYMENT_RECHNUNG_ORDER_STATUS_ID', 'MODULE_PAYMENT_RECHNUNG_SORT_ORDER');
    }
  }
?>
